## liborcus 0.18.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
cmake_policy(SET CMP0048 NEW)

set(ORCUS_MAJOR_VERSION 0)
set(ORCUS_MINOR_VERSION 18)
set(ORCUS_MICRO_VERSION 1)
set(ORCUS_MAJOR_API_VERSION 0)
set(ORCUS_MINOR_API_VERSION 18)
set(ORCUS_VERSION ${ORCUS_MAJOR_VERSION}.${ORCUS_MINOR_VERSION}.${ORCUS_MICRO_VERSION})
set(ORCUS_API_VERSION ${ORCUS_MAJOR_API_VERSION}.${ORCUS_MINOR_API_VERSION})

project(orcus VERSION ${ORCUS_VERSION} LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 17)

set(MDDS_INCLUDEDIR "" CACHE STRING "path to mdds header directory.")
set(IXION_INCLUDEDIR "" CACHE STRING "path to ixion header directory.")
set(IXION_LIBRARYDIR "" CACHE STRING "path to ixion library directory.")
option(WITH_CPU_FEATURES "whether or not to enable use of CPU extensions.")
option(WITH_SSE42 "whether or not to enable use of SSE 4.2.")
option(WITH_AVX2 "whether or not to enable use of AVX2.")

find_package(Boost COMPONENTS program_options filesystem)
find_package(Threads)
find_package(Python3)
find_package(ZLIB)

include(GNUInstallDirs)

enable_testing()
set(CMAKE_CTEST_COMMAND ctest)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

find_library(IXION_LIB ixion-0.18 PATHS ${IXION_LIBRARYDIR})

if(NOT IXION_LIB)
    message(FATAL_ERROR "Ixion not found.")
endif()

message(STATUS "Found Ixion: ${IXION_LIB}")

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251 /wd4275 /wd4267 /wd4244 /MP")
    add_definitions(
        -D_CRT_SECURE_NO_WARNINGS
    )
endif(MSVC)

add_definitions(
    ${Boost_LIB_DIAGNOSTIC_DEFINITIONS}
)

if(WITH_CPU_FEATURES)
    add_definitions(-D__ORCUS_CPU_FEATURES)
    message(STATUS "Enabling use of CPU features...")

    if(WITH_AVX2)
        message(STATUS "Enabling AVX2...")
        if(MSVC)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX2")
        else()
            add_definitions(-D__AVX2__)
        endif()
    endif()

    if(WITH_SSE42)
        message(STATUS "Enabling SSE 4.2...")
        add_definitions(-D__SSE4_2__)
    endif()

endif()

include_directories(
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/src/include
    ${Boost_INCLUDE_DIR}
    ${MDDS_INCLUDEDIR}
    ${IXION_INCLUDEDIR}
    ${ZLIB_INCLUDE_DIRS}
)

link_directories(${Boost_LIBRARY_DIRS})

add_subdirectory(include)
add_subdirectory(src)

=== src/CMakeLists.txt ===

add_subdirectory(test)
add_subdirectory(parser)
add_subdirectory(liborcus)
add_subdirectory(spreadsheet)

add_executable(orcus-detect
    ${PROJECT_SOURCE_DIR}/src/orcus_detect_main.cpp
)

add_executable(orcus-css-dump
    ${PROJECT_SOURCE_DIR}/src/orcus_css_dump.cpp
)

add_executable(orcus-zip-dump
    ${PROJECT_SOURCE_DIR}/src/orcus_zip_dump.cpp
)

add_executable(orcus-json
    ${PROJECT_SOURCE_DIR}/src/cli_global.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_json_cli.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_json_cli_map.cpp
)

add_executable(orcus-yaml
    ${PROJECT_SOURCE_DIR}/src/orcus_yaml_main.cpp
)

add_executable(orcus-csv
    ${PROJECT_SOURCE_DIR}/src/orcus_csv_main.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_filter_global.cpp
)

add_executable(orcus-xml
    ${PROJECT_SOURCE_DIR}/src/orcus_xml_main.cpp
    ${PROJECT_SOURCE_DIR}/src/cli_global.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_filter_global.cpp
)

add_executable(orcus-ods
    ${PROJECT_SOURCE_DIR}/src/orcus_ods_main.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_filter_global.cpp
)

add_executable(orcus-styles-ods
    ${PROJECT_SOURCE_DIR}/src/orcus_ods_styles.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_filter_global.cpp
)

add_executable(orcus-xlsx
    ${PROJECT_SOURCE_DIR}/src/orcus_xlsx_main.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_filter_global.cpp
)

add_executable(orcus-xls-xml
    ${PROJECT_SOURCE_DIR}/src/orcus_xls_xml_main.cpp
    ${PROJECT_SOURCE_DIR}/src/orcus_filter_global.cpp
)

target_link_libraries(orcus-detect orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-css-dump orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-zip-dump orcus-parser-${ORCUS_API_VERSION})
target_link_libraries(orcus-json orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-yaml orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-csv orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-xml orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-ods orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-styles-ods orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-xlsx orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-xls-xml orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})

add_executable(orcus-env-dump EXCLUDE_FROM_ALL
    orcus_env_dump.cpp
)

target_link_libraries(orcus-env-dump orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})

# test programs

add_executable(orcus-test-csv EXCLUDE_FROM_ALL
    orcus_test_csv.cpp
    orcus_test_global.cpp
)

add_executable(orcus-test-ods EXCLUDE_FROM_ALL
    orcus_test_ods.cpp
)

add_executable(orcus-test-xls-xml EXCLUDE_FROM_ALL
    orcus_test_xls_xml.cpp
    orcus_test_global.cpp
)

add_executable(orcus-test-xlsx EXCLUDE_FROM_ALL
    orcus_test_xlsx.cpp
)

add_executable(orcus-test-xml EXCLUDE_FROM_ALL
    orcus_test_xml.cpp
)

add_executable(orcus-test-xml-mapped EXCLUDE_FROM_ALL
    orcus_test_xml_mapped.cpp
    orcus_test_global.cpp
)

add_executable(orcus-test-json-mapped EXCLUDE_FROM_ALL
    orcus_test_json_mapped.cpp
)

add_executable(orcus-test-import-ods EXCLUDE_FROM_ALL
    orcus_test_import_ods.cpp
)

set(_TESTS
    orcus-test-csv
    orcus-test-ods
    orcus-test-xls-xml
    orcus-test-xlsx
    orcus-test-xml
    orcus-test-xml-mapped
    orcus-test-json-mapped
    orcus-test-import-ods
)

foreach(_TEST ${_TESTS})
    target_link_libraries(${_TEST}
        orcus-parser-${ORCUS_API_VERSION}
        orcus-spreadsheet-model-${ORCUS_API_VERSION}
        orcus-${ORCUS_API_VERSION}
        orcus-test
    )

    target_compile_definitions(${_TEST} PRIVATE
        SRCDIR="${PROJECT_SOURCE_DIR}"
    )

    add_test(${_TEST} ${_TEST})

    # Make sure the liborcus-parser library file is present in the same directory
    # as the test program.
    add_custom_command(TARGET ${_TEST} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
        $<TARGET_FILE:orcus-parser-${ORCUS_API_VERSION}>
        $<TARGET_FILE:orcus-${ORCUS_API_VERSION}>
        $<TARGET_FILE:orcus-spreadsheet-model-${ORCUS_API_VERSION}>
        $<TARGET_FILE_DIR:${_TEST}>
    )
endforeach()

add_dependencies(check ${_TESTS})

install(
    TARGETS
        orcus-detect
        orcus-css-dump
        orcus-zip-dump
        orcus-json
        orcus-yaml
        orcus-csv
        orcus-xml
        orcus-ods
        orcus-styles-ods
        orcus-xlsx
        orcus-xls-xml
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/liborcus/CMakeLists.txt ===

add_library(orcus-${ORCUS_API_VERSION} SHARED
# core
    config.cpp
    css_document_tree.cpp
    css_selector.cpp
    detection_result.cpp
    dom_tree.cpp
    format_detection.cpp
    formula_result.cpp
    info.cpp
    interface.cpp
    json_document_tree.cpp
    json_map_tree.cpp
    json_structure_mapper.cpp
    json_structure_tree.cpp
    json_util.cpp
    spreadsheet_interface.cpp
    orcus_csv.cpp
    orcus_json.cpp
    orcus_xml.cpp
    orcus_xml_impl.cpp
    orcus_xml_map_def.cpp
    measurement.cpp
    xml_context_base.cpp
    xml_context_global.cpp
    xml_element_types.cpp
    xml_element_validator.cpp
    xml_empty_context.cpp
    xml_map_tree.cpp
    xml_stream_handler.cpp
    xml_stream_parser.hpp
    xml_stream_parser.cpp
    xml_simple_stream_handler.cpp
    xml_structure_mapper.cpp
    xml_structure_tree.cpp
    xml_util.cpp
    xpath_parser.cpp
    yaml_document_tree.cpp
    ooxml_namespace_types.cpp
    ooxml_namespace_types.hpp
    odf_namespace_types.hpp
    odf_namespace_types.cpp
    gnumeric_namespace_types.cpp
    xls_xml_namespace_types.cpp
    session_context.cpp
    spreadsheet_interface.cpp
    spreadsheet_iface_util.cpp
    spreadsheet_types.cpp
    spreadsheet_impl_types.cpp
    string_helper.cpp
# xlsx filter
    ooxml_content_types.cpp
    ooxml_global.cpp
    ooxml_schemas.cpp
    ooxml_tokens.cpp
    ooxml_types.cpp
    opc_context.cpp
    opc_reader.cpp
    orcus_xlsx.cpp
    orcus_import_xlsx.cpp
    xlsx_context.cpp
    xlsx_drawing_context.cpp
    xlsx_handler.cpp
    xlsx_helper.cpp
    xlsx_session_data.cpp
    xlsx_revision_context.cpp
    xlsx_pivot_context.cpp
    xlsx_sheet_context.cpp
    xlsx_conditional_format_context.cpp
    xlsx_table_context.cpp
    xlsx_autofilter_context.cpp
    xlsx_types.cpp
    xlsx_workbook_context.cpp
# xls-xml filter
    xls_xml_tokens.cpp
    orcus_xls_xml.cpp
    xls_xml_detection_handler.cpp
    xls_xml_handler.cpp
    xls_xml_context.cpp
# ods filter
    odf_document_styles_context.cpp
    odf_para_context.cpp
    odf_styles.cpp
    odf_styles_context.cpp
    odf_style_context.cpp
    odf_number_format_context.cpp
    odf_tokens.cpp
    ods_content_xml_context.cpp
    ods_dde_links_context.cpp
    ods_session_data.cpp
    odf_helper.cpp
    orcus_ods.cpp
    orcus_import_ods.cpp
# gnumeric filter
# TODO : document a way to build boost with bzip2 and zlib options, or find
# a way to make this a build-time option.
#   gnumeric_detection_handler.cpp
#   gnumeric_cell_context.cpp
#   gnumeric_context.cpp
#   gnumeric_handler.cpp
#   gnumeric_helper.cpp
#   gnumeric_sheet_context.cpp
#   gnumeric_tokens.cpp
#   orcus_gnumeric.cpp
)

configure_file(constants.inl.in ${CMAKE_CURRENT_BINARY_DIR}/constants.inl)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION})

target_compile_definitions(orcus-${ORCUS_API_VERSION} PRIVATE
    __ORCUS_BUILDING_DLL
    __ORCUS_XLSX
    __ORCUS_ODS
    __ORCUS_XLS_XML
)

# single-file test programs

set(_TESTS
    common-test
    css-document-tree-test
    dom-tree-test
    format-detection-test
#   gnumeric-cell-context-test
#   gnumeric-helper-test
#   gnumeric-sheet-context-test
    json-document-tree-test
    json-structure-tree-test
    xml-structure-tree-test
    yaml-document-tree-test
)

foreach(_TEST ${_TESTS})
    set(_TEST_FILE ${_TEST}.cpp)
    string(REPLACE "-" "_" _TEST_FILE ${_TEST_FILE})
    add_executable(${_TEST} EXCLUDE_FROM_ALL ${_TEST_FILE})
    target_link_libraries(${_TEST}
        orcus-${ORCUS_API_VERSION}
        orcus-parser-${ORCUS_API_VERSION}
        orcus-test
    )
    target_compile_definitions(${_TEST} PRIVATE
        SRCDIR="${PROJECT_SOURCE_DIR}"
    )
    add_test(${_TEST} ${_TEST})

    # Make sure the orcus-parser library file is present in the same directory
    # as the test program.
    add_custom_command(TARGET ${_TEST} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
        $<TARGET_FILE:orcus-parser-${ORCUS_API_VERSION}>
        $<TARGET_FILE_DIR:${_TEST}>
    )

endforeach()

# multi-file test programs

add_executable(odf-helper-test EXCLUDE_FROM_ALL
    odf_helper_test.cpp
    odf_helper.cpp
    string_helper.cpp
)

add_executable(xlsx-sheet-context-test EXCLUDE_FROM_ALL
    formula_result.cpp
    ooxml_global.cpp
    ooxml_namespace_types.cpp
    ooxml_schemas.cpp
    ooxml_tokens.cpp
    ooxml_types.cpp
    session_context.cpp
    xlsx_autofilter_context.cpp
    xlsx_conditional_format_context.cpp
    xlsx_helper.cpp
    xlsx_session_data.cpp
    xlsx_sheet_context.cpp
    xlsx_sheet_context_test.cpp
    xlsx_types.cpp
    xml_context_base.cpp
    xml_context_global.cpp
    xml_element_types.cpp
    xml_element_validator.cpp
    xml_empty_context.cpp
    xml_util.cpp
)

add_executable(xml-map-tree-test EXCLUDE_FROM_ALL
    xml_map_tree_test.cpp
    spreadsheet_impl_types.cpp
    xml_map_tree.cpp
    xpath_parser.cpp
)

add_executable(json-map-tree-test EXCLUDE_FROM_ALL
    json_map_tree_test.cpp
    json_map_tree.cpp
    spreadsheet_impl_types.cpp
)

add_executable(xpath-parser-test EXCLUDE_FROM_ALL
    xpath_parser_test.cpp
    xpath_parser.cpp
)

target_compile_definitions(xlsx-sheet-context-test PRIVATE
    __ORCUS_STATIC_LIB
)

target_link_libraries(odf-helper-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION})
target_link_libraries(xlsx-sheet-context-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION} orcus-test)
target_link_libraries(xml-map-tree-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION} orcus-test)
target_link_libraries(json-map-tree-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION})
target_link_libraries(xpath-parser-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION})
add_test(odf-helper-test odf-helper-test)
add_test(xlsx-sheet-context-test xlsx-sheet-context-test)
add_test(xml-map-tree-test xml-map-tree-test)

add_dependencies(check
    ${_TESTS}
    odf-helper-test
    xlsx-sheet-context-test
    xml-map-tree-test
    json-map-tree-test
    xpath-parser-test
)

install(
    TARGETS
        orcus-${ORCUS_API_VERSION}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/parser/CMakeLists.txt ===

add_library(orcus-parser-${ORCUS_API_VERSION} SHARED
    base64.cpp
    cell_buffer.cpp
    css_parser_base.cpp
    css_types.cpp
    csv_parser_base.cpp
    exception.cpp
    json_global.cpp
    json_parser_base.cpp
    json_parser_thread.cpp
    parser_base.cpp
    parser_global.cpp
    pstring.cpp
    sax_parser_base.cpp
    sax_token_parser.cpp
    sax_token_parser_thread.cpp
    stream.cpp
    string_pool.cpp
    tokens.cpp
    types.cpp
    utf8.cpp
    xml_namespace.cpp
    xml_writer.cpp
    yaml_parser_base.cpp
    zip_archive.cpp
    zip_archive_stream.cpp
)

target_compile_definitions(orcus-parser-${ORCUS_API_VERSION} PRIVATE
    __ORCUS_PSR_BUILDING_DLL
    _SILENCE_CXX17_CODECVT_HEADER_DEPRECATION_WARNING
)
target_link_libraries(orcus-parser-${ORCUS_API_VERSION} ${ZLIB_LIBRARIES})

# test programs

set(_TESTS
    base64-test
    css-parser-test
    csv-parser-test
    json-parser-test
    parser-base-test
    parser-global-test
    sax-ns-parser-test
    sax-parser-test
    sax-token-parser-test
    stream-test
    string-pool-test
    threaded-json-parser-test
    threaded-sax-token-parser-test
    types-test
    xml-namespace-test
    xml-writer-test
    yaml-parser-test
    zip-archive-test
)

foreach(_TEST ${_TESTS})
    set(_TEST_FILE ${_TEST}.cpp)
    string(REPLACE "-" "_" _TEST_FILE ${_TEST_FILE})
    add_executable(${_TEST} EXCLUDE_FROM_ALL ${_TEST_FILE})
    target_link_libraries(${_TEST}
        orcus-parser-${ORCUS_API_VERSION}
        orcus-test
    )

    target_compile_definitions(${_TEST} PRIVATE
        SRCDIR="${PROJECT_SOURCE_DIR}"
    )

    add_test(${_TEST} ${_TEST})
endforeach()

add_dependencies(check ${_TESTS})

# utf8-test

add_executable(utf8-test utf8.cpp utf8_test.cpp)
target_link_libraries(utf8-test orcus-parser-${ORCUS_API_VERSION})
add_test(utf8-test utf8-test)
add_dependencies(check utf8-test)

install(
    TARGETS
        orcus-parser-${ORCUS_API_VERSION}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== debian/changelog ===
liborcus (0.18.1-2) experimental; urgency=medium

  * Update tests/control: 0.17->0.18 (closes: #1038690) 

 -- Rene Engelhard <rene@debian.org>  Tue, 20 Jun 2023 17:39:51 +0200

liborcus (0.18.1-1) experimental; urgency=medium

  * New upstream version 0.18.1

 -- Rene Engelhard <rene@debian.org>  Fri, 10 Feb 2023 19:04:45 +0100

liborcus (0.18.0-1) experimental; urgency=medium

  * New upstream version 0.18.0

  * explicitely build with --enable-static for now

 -- Rene Engelhard <rene@debian.org>  Fri, 13 Jan 2023 19:46:14 +0100

=== debian/control ===
Source: liborcus
Priority: optional
Section: libs
Maintainer: Debian LibreOffice Maintainers <debian-openoffice@lists.debian.org>
Uploaders:
 Rene Engelhard <rene@debian.org>,
Build-Depends:
 chrpath,
 debhelper-compat (= 13),
 dh-python,
 dpkg-dev (>= 1.16.1),
 libboost-date-time-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libixion-dev (>= 0.18.0~),
 libixion-dev (<< 0.19.0~),
 libmdds-dev (>= 2.1),
 libmdds-dev (<< 2.2~),
 pkg-config,
 python3,
 python3-dev,
 sphinx-common,
 zlib1g-dev,
Build-Depends-Indep:
 doxygen,
 python3-breathe,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-sphinx-argparse
Build-Conflicts:
 python-sphinx,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://gitlab.com/orcus/orcus
Vcs-Git: https://salsa.debian.org/libreoffice-team/liborcus.git
Vcs-Browser: https://salsa.debian.org/libreoffice-team/liborcus

Package: liborcus-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 liborcus-0.18-0 (= ${binary:Version}),
 liborcus-mso-0.18-0 (= ${binary:Version}),
 liborcus-parser-0.18-0 (= ${binary:Version}),
 liborcus-spreadsheet-model-0.18-0 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 libixion-dev (>= 0.18.0~),
Description: library for processing spreadsheet documents -- development
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.
 .
 This package contains headers, pkg-config file and static library for
 developing applications using Orcus.

Package: liborcus-0.18-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for processing spreadsheet documents
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.

Package: liborcus-mso-0.18-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for processing spreadsheet documents - MS Office encryption library
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.
 .
 This package contains a library for handling MS Office encryption.

Package: liborcus-parser-0.18-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for processing spreadsheet documents - parser library
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.
 .
 This package contains the parser library.

Package: liborcus-spreadsheet-model-0.18-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for processing spreadsheet documents - spreadsheet model library
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.
 .
 This package contains a library abstracting the spreadsheet model.

Package: python3-orcus
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: library for processing spreadsheet documents - Python bindings
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.
 .
 This package contains the Python bindings for liborcus.

Package: liborcus-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Built-Using:
 ${sphinxdoc:Built-Using},
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: library for processing spreadsheet documents - documentation
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.
 .
 This package contains the API documentation.

Package: liborcus-bin
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library for processing spreadsheet documents - binaries
 Orcus is a library that provides a collection of standalone file processing
 filters.  It is currently focused on providing filters for spreadsheet
 documents, but filters for other productivity application types (such as
 wordprocessor and presentation) are in consideration.
 .
 The library currently includes filters for xlsx, ods, csv, and generic XML
 formats.
 .
 This package contains the command-line applications for converting documents.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

%:
	dh $@  --with python3 --with sphinxdoc

override_dh_auto_clean:
	rm -rf src/python/orcus/__pycache__/
	rm -rf test/python/__pycache__
	rm -rf src/python/orcus/tools/__pycache__
	rm -rf 
	dh_auto_clean
	rm -rf doc/_doxygen doc/tmp

override_dh_auto_configure-arch:
	dh_auto_configure -- --disable-silent-rules --disable-werror --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) --enable-static

override_dh_auto_build-indep:
	cd doc && \
		doxygen doxygen.conf && \
		mkdir tmp && sphinx-build -v -a . tmp

override_dh_auto_configure-indep:

ifeq "$(DEB_HOST_ARCH)" "s390"
override_dh_auto_test:

else
override_dh_auto_test:
	dh_auto_test
endif

override_dh_auto_install:
	# otherwise dh_auto_install -pliborcus-doc doesn't work because there's
	# no debian/tmp it can cd from
	mkdir -p debian/tmp
	if [ -d src/.libs ]; then dh_auto_install; \
	find debian/tmp/usr/lib/python* -name "*.*a" -exec rm {} \; ; \
	chrpath -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/liborcus-0.18.so.0.0.0; \
	else dh_auto_install -- -pliborcus-doc; fi

override_dh_makeshlibs:
	dh_makeshlibs -VNone

override_dh_shlibdeps:
	dh_shlibdeps

## liborcus 0.19.2

=== doc/requirements.txt ===
breathe
sphinx-argparse
sphinx-rtd-theme

=== debian/changelog ===
liborcus (0.19.2-6) unstable; urgency=medium

  * fix new restriction for the "import orcus" test... 

 -- Rene Engelhard <rene@debian.org>  Sun, 22 Sep 2024 01:46:00 +0200

liborcus (0.19.2-5) unstable; urgency=medium

  * build with -ffloat-store on i386 
  * Add allow-stderr restriction to "unit" test due to the gcc 7.x ABI change
    warnings during the bulld in the test stage; while at it mark the
    "import orcus" test superficial

 -- Rene Engelhard <rene@debian.org>  Sat, 21 Sep 2024 20:45:08 +0200

liborcus (0.19.2-4) unstable; urgency=medium

  * add updated debian/watch, thanks Patrice Duroux (closes: #1079919)
  * fix autopkgtest, work around autopkgtest build-needed builds doing
    "nocheck" which misses files we need in the test run...

 -- Rene Engelhard <rene@debian.org>  Thu, 29 Aug 2024 17:13:57 +0200

liborcus (0.19.2-3) unstable; urgency=medium

  * upload to unstable 

 -- Rene Engelhard <rene@debian.org>  Fri, 24 Nov 2023 18:24:33 +0100

liborcus (0.19.2-2) experimental; urgency=medium

  * merge 0.17.2-2 changes....:

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on dpkg-dev.

  [ Mattia Rizzolo ]
  * Declaratively use dh-sequence-python3.
  * Declaratively use dh-sequence-sphinxdoc, also limiting it to the indep
    build.
  * Bump Standards-Version to 4.6.0, no changes needed.
  * Fix d/watch so it matches with the new GitLab layout.
  * Update d/copyright after the previous update (just following lintian).

 -- Rene Engelhard <rene@debian.org>  Fri, 24 Nov 2023 18:09:36 +0100

liborcus (0.19.2-1) experimental; urgency=medium

  * New upstream version 0.19.2
    - fixes segmentation fault in orcus-test-xml-mapped (closes: #1054376)

 -- Rene Engelhard <rene@debian.org>  Fri, 10 Nov 2023 18:21:38 +0100

liborcus (0.19.1-2) experimental; urgency=medium

  * use dh_makeshlibs -VUpstream-Version to bump .shlibs to >= 0.19.1

 -- Rene Engelhard <rene@debian.org>  Fri, 27 Oct 2023 19:06:26 +0000

liborcus (0.19.1-1) experimental; urgency=medium

  * New upstream version 0.19.1

 -- Rene Engelhard <rene@debian.org>  Mon, 23 Oct 2023 17:50:38 +0200

liborcus (0.19.0-2) experimental; urgency=medium

  * debian/rules: export DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=fast

 -- Rene Engelhard <rene@debian.org>  Sun, 22 Oct 2023 09:00:42 +0000

liborcus (0.19.0-1) experimental; urgency=medium

  * New upstream version 0.19.0

 -- Rene Engelhard <rene@debian.org>  Tue, 03 Oct 2023 14:44:19 +0200

=== debian/control ===
--- 
+++ 
@@ -7,23 +7,22 @@
 Build-Depends:
  chrpath,
  debhelper-compat (= 13),
- dh-python,
- dpkg-dev (>= 1.16.1),
+ dh-sequence-python3,
  libboost-date-time-dev,
  libboost-filesystem-dev,
  libboost-iostreams-dev,
  libboost-program-options-dev,
  libboost-system-dev,
- libixion-dev (>= 0.18.0~),
- libixion-dev (<< 0.19.0~),
- libmdds-dev (>= 2.1),
+ libixion-dev (>= 0.19.0~),
+ libixion-dev (<< 0.20.0~),
+ libmdds-dev (>= 2.1.1),
  libmdds-dev (<< 2.2~),
  pkg-config,
  python3,
  python3-dev,
- sphinx-common,
  zlib1g-dev,
 Build-Depends-Indep:
+ dh-sequence-sphinxdoc,
  doxygen,
  python3-breathe,
  python3-sphinx,
@@ -31,7 +30,7 @@
  python3-sphinx-argparse
 Build-Conflicts:
  python-sphinx,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/orcus/orcus
 Vcs-Git: https://salsa.debian.org/libreoffice-team/liborcus.git

=== debian/rules ===
--- 
+++ 
@@ -5,14 +5,18 @@
 
 include /usr/share/dpkg/architecture.mk
 
+export DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=fast
+ifeq "$(DEB_HOST_ARCH)" "i386"
+export DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
+endif
+
 %:
-	dh $@  --with python3 --with sphinxdoc
+	dh $@
 
 override_dh_auto_clean:
 	rm -rf src/python/orcus/__pycache__/
 	rm -rf test/python/__pycache__
 	rm -rf src/python/orcus/tools/__pycache__
-	rm -rf 
 	dh_auto_clean
 	rm -rf doc/_doxygen doc/tmp
 
@@ -44,7 +48,9 @@
 	else dh_auto_install -- -pliborcus-doc; fi
 
 override_dh_makeshlibs:
-	dh_makeshlibs -VNone
+	# we need >= 0.19.1 for orcus::create_filter() (see LibreOffices
+	# https://cgit.freedesktop.org/libreoffice/core/commit/?id=b14583ba37a6d7ce398ccd3cf339f954785b03d8
+	dh_makeshlibs -VUpstream-Version
 
 override_dh_shlibdeps:
 	dh_shlibdeps

=== debian/tests/control ===
Test-Command: set -e ; cd "$AUTOPKGTEST_TMP" ; python3 -c "import orcus; print(orcus)"
Depends:
 python3,
 python3-orcus
Restrictions: superficial

Tests: unit
Depends:
 liborcus-0.18-0,
 liborcus-spreadsheet-model-0.18-0,
 python3-orcus,
 @builddeps@,
Restrictions: build-needed, rw-build-tree, allow-stderr

## liborcus 0.20.1

=== debian/changelog ===
liborcus (0.20.1-1) experimental; urgency=medium

  * New upstream version 0.20.1

 -- Rene Engelhard <rene@debian.org>  Sun, 25 May 2025 09:26:07 +0200

liborcus (0.20.0-2) experimental; urgency=medium

  [ Pino Toscano ]
  * Build with -ffloat-store on any i386 architecture, not only on Linux.

  [ Rene Engelhard ]
  * apply patch from LibreOffice master to fix autofilter crash/assertion 

 -- Rene Engelhard <rene@debian.org>  Sat, 19 Apr 2025 17:19:25 +0200

liborcus (0.20.0-1) experimental; urgency=medium

  * New upstream version 0.20.0
    - fixes build with gcc 15 (closes: #1097242)

 -- Rene Engelhard <rene@debian.org>  Thu, 06 Feb 2025 20:58:23 +0100

=== debian/control ===
--- 
+++ 
@@ -13,10 +13,10 @@
  libboost-iostreams-dev,
  libboost-program-options-dev,
  libboost-system-dev,
- libixion-dev (>= 0.19.0~),
- libixion-dev (<< 0.20.0~),
- libmdds-dev (>= 2.1.1),
- libmdds-dev (<< 2.2~),
+ libixion-dev (>= 0.20.0~),
+ libixion-dev (<< 0.21.0~),
+ libmdds-dev (>= 3.0),
+ libmdds-dev (<< 3.1~),
  pkg-config,
  python3,
  python3-dev,
@@ -41,13 +41,13 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- liborcus-0.18-0 (= ${binary:Version}),
- liborcus-mso-0.18-0 (= ${binary:Version}),
- liborcus-parser-0.18-0 (= ${binary:Version}),
- liborcus-spreadsheet-model-0.18-0 (= ${binary:Version}),
+ liborcus-0.20-0 (= ${binary:Version}),
+ liborcus-mso-0.20-0 (= ${binary:Version}),
+ liborcus-parser-0.20-0 (= ${binary:Version}),
+ liborcus-spreadsheet-model-0.20-0 (= ${binary:Version}),
  ${misc:Depends},
 Recommends:
- libixion-dev (>= 0.18.0~),
+ libixion-dev (>= 0.20.0~),
 Description: library for processing spreadsheet documents -- development
  Orcus is a library that provides a collection of standalone file processing
  filters.  It is currently focused on providing filters for spreadsheet
@@ -60,7 +60,7 @@
  This package contains headers, pkg-config file and static library for
  developing applications using Orcus.
 
-Package: liborcus-0.18-0
+Package: liborcus-0.20-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -77,7 +77,7 @@
  The library currently includes filters for xlsx, ods, csv, and generic XML
  formats.
 
-Package: liborcus-mso-0.18-0
+Package: liborcus-mso-0.20-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -96,7 +96,7 @@
  .
  This package contains a library for handling MS Office encryption.
 
-Package: liborcus-parser-0.18-0
+Package: liborcus-parser-0.20-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -115,7 +115,7 @@
  .
  This package contains the parser library.
 
-Package: liborcus-spreadsheet-model-0.18-0
+Package: liborcus-spreadsheet-model-0.20-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:

## liborcus 0.20.2

=== debian/changelog ===
liborcus (0.20.2-2) unstable; urgency=medium

  * upload to unstable 

 -- Rene Engelhard <rene@debian.org>  Fri, 22 Aug 2025 13:30:06 +0200

liborcus (0.20.2-1) experimental; urgency=medium

  * New upstream version 0.20.2

 -- Rene Engelhard <rene@debian.org>  Wed, 20 Aug 2025 06:22:28 +0200

liborcus (0.20.1-2) experimental; urgency=medium

  * debian/control: allow mdds 3.1 (still mdds-3.0.pc)

 -- Rene Engelhard <rene@debian.org>  Fri, 11 Jul 2025 16:12:19 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  libixion-dev (>= 0.20.0~),
  libixion-dev (<< 0.21.0~),
  libmdds-dev (>= 3.0),
- libmdds-dev (<< 3.1~),
+ libmdds-dev (<< 3.2~),
  pkg-config,
  python3,
  python3-dev,

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 include /usr/share/dpkg/architecture.mk
 
 export DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=fast
-ifeq "$(DEB_HOST_ARCH)" "i386"
+ifeq "$(DEB_HOST_ARCH_CPU)" "i386"
 export DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
 endif
 
@@ -44,7 +44,7 @@
 	mkdir -p debian/tmp
 	if [ -d src/.libs ]; then dh_auto_install; \
 	find debian/tmp/usr/lib/python* -name "*.*a" -exec rm {} \; ; \
-	chrpath -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/liborcus-0.18.so.0.0.0; \
+	chrpath -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/liborcus-0.20.so.0.0.0; \
 	else dh_auto_install -- -pliborcus-doc; fi
 
 override_dh_makeshlibs:

=== debian/tests/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 
 Tests: unit
 Depends:
- liborcus-0.18-0,
- liborcus-spreadsheet-model-0.18-0,
+ liborcus-0.20-0,
+ liborcus-spreadsheet-model-0.20-0,
  python3-orcus,
  @builddeps@,
 Restrictions: build-needed, rw-build-tree, allow-stderr

=== debian/watch ===
version=4

opts=searchmode=plain,downloadurlmangle=s|gitlab.com/orcus/orcus/repository/(@ANY_VERSION@)/archive.tar.gz|kohei.us/files/orcus/src/@PACKAGE@-$1.tar.xz|,repack,compression=xz \
https://gitlab.com/orcus/orcus/tags?sort=updated_desc /orcus/orcus/-/archive/@ANY_VERSION@/[^/]+\.tar\.gz

## liborcus 0.21.0

=== debian/changelog ===
liborcus (0.21.0-6) experimental; urgency=medium

  * disable parquet filter on bigendian 

 -- Rene Engelhard <rene@debian.org>  Sat, 21 Feb 2026 09:28:27 +0100

liborcus (0.21.0-5) experimental; urgency=medium

  * enable parquet filter now that we have apache arrow available (on archs
    where it is buildable
  * add patch from upstream git to "make it buildable with Apache Arrow
    23.0.0" (which also fixes the build with 22.0.0 for me)
  * hack around Apache Arrow 23.0.1 now apparently needing <span>, which works
    with --std=gnu++20 only

 -- Rene Engelhard <rene@debian.org>  Tue, 17 Feb 2026 17:40:26 +0100

liborcus (0.21.0-4) unstable; urgency=medium

  * remove B-D on libboost-system-dev, unused and obsolete
    (closes: #1127222)
  * merge from Ubuntu:
    - Update autopkg test dependencies. (closes: #1127433)

 -- Rene Engelhard <rene@debian.org>  Sun, 08 Feb 2026 20:04:41 +0100

liborcus (0.21.0-3) unstable; urgency=medium

  * upload to unstable 

 -- Rene Engelhard <rene@debian.org>  Wed, 28 Jan 2026 20:52:48 +0100

liborcus (0.21.0-2) experimental; urgency=medium

  * debian/control: allow mdds 3.2 (still mdds-3.0.pc) 

 -- Rene Engelhard <rene@debian.org>  Wed, 17 Dec 2025 20:23:27 +0100

liborcus (0.21.0-1) experimental; urgency=medium

  * New upstream version 0.21.0
  * 0.20 -> 0.21 in the SOVERSION

 -- Rene Engelhard <rene@debian.org>  Tue, 16 Sep 2025 16:54:00 +0200

=== debian/control ===
--- 
+++ 
@@ -12,11 +12,11 @@
  libboost-filesystem-dev,
  libboost-iostreams-dev,
  libboost-program-options-dev,
- libboost-system-dev,
  libixion-dev (>= 0.20.0~),
  libixion-dev (<< 0.21.0~),
  libmdds-dev (>= 3.0),
- libmdds-dev (<< 3.2~),
+ libmdds-dev (<< 3.3~),
+ libparquet-dev [amd64 arm64 armhf i386 loong64 ppc64el riscv64],
  pkg-config,
  python3,
  python3-dev,
@@ -41,10 +41,10 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- liborcus-0.20-0 (= ${binary:Version}),
- liborcus-mso-0.20-0 (= ${binary:Version}),
- liborcus-parser-0.20-0 (= ${binary:Version}),
- liborcus-spreadsheet-model-0.20-0 (= ${binary:Version}),
+ liborcus-0.21-0 (= ${binary:Version}),
+ liborcus-mso-0.21-0 (= ${binary:Version}),
+ liborcus-parser-0.21-0 (= ${binary:Version}),
+ liborcus-spreadsheet-model-0.21-0 (= ${binary:Version}),
  ${misc:Depends},
 Recommends:
  libixion-dev (>= 0.20.0~),
@@ -60,7 +60,7 @@
  This package contains headers, pkg-config file and static library for
  developing applications using Orcus.
 
-Package: liborcus-0.20-0
+Package: liborcus-0.21-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -77,7 +77,7 @@
  The library currently includes filters for xlsx, ods, csv, and generic XML
  formats.
 
-Package: liborcus-mso-0.20-0
+Package: liborcus-mso-0.21-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -96,7 +96,7 @@
  .
  This package contains a library for handling MS Office encryption.
 
-Package: liborcus-parser-0.20-0
+Package: liborcus-parser-0.21-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -115,7 +115,7 @@
  .
  This package contains the parser library.
 
-Package: liborcus-spreadsheet-model-0.20-0
+Package: liborcus-spreadsheet-model-0.21-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends:

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,12 @@
 export DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=fast
 ifeq "$(DEB_HOST_ARCH_CPU)" "i386"
 export DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
+endif
+
+ifeq "$(DEB_HOST_ARCH)" "$(findstring $(DEB_HOST_ARCH),amd64 armhf arm64 i386 loong64 ppc64 ppc64el riscv64 s390x)"
+ifeq "$(DEB_HOST_ARCH_ENDIAN)" "little"
+ENABLE_PARQUET=y
+endif
 endif
 
 %:
@@ -21,7 +27,18 @@
 	rm -rf doc/_doxygen doc/tmp
 
 override_dh_auto_configure-arch:
+ifeq "$(ENABLE_PARQUET)" "y"
+	dh_auto_configure -- --disable-silent-rules --disable-werror --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) --enable-static --with-parquet-filter
+else
 	dh_auto_configure -- --disable-silent-rules --disable-werror --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) --enable-static
+endif
+
+override_dh_auto_build-arch:
+ifeq "$(ENABLE_PARQUET)" "y"
+	# needs span, which needs C++20...
+	sed -i "s/-std=gnu++17/-std=gnu++20/" src/liborcus/Makefile
+endif
+	dh_auto_build
 
 override_dh_auto_build-indep:
 	cd doc && \
@@ -44,12 +61,10 @@
 	mkdir -p debian/tmp
 	if [ -d src/.libs ]; then dh_auto_install; \
 	find debian/tmp/usr/lib/python* -name "*.*a" -exec rm {} \; ; \
-	chrpath -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/liborcus-0.20.so.0.0.0; \
+	chrpath -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/liborcus-0.21.so.0.0.0; \
 	else dh_auto_install -- -pliborcus-doc; fi
 
 override_dh_makeshlibs:
-	# we need >= 0.19.1 for orcus::create_filter() (see LibreOffices
-	# https://cgit.freedesktop.org/libreoffice/core/commit/?id=b14583ba37a6d7ce398ccd3cf339f954785b03d8
 	dh_makeshlibs -VUpstream-Version
 
 override_dh_shlibdeps:
